package be.jeffcheasey88.peeratcode.parser.java;

import be.jeffcheasey88.peeratcode.parser.Token;

public class Value extends JavaElement{
	
	private Token token;
	private JavaElement content;
	
	Value(){}
	
	public Value(Token token){
		this.token = token;
	}
	
	public Value(JavaElement content){
		this.content = content;
	}
	
	public Token getToken(){
		return this.token;
	}
	
	public JavaElement getContent(){
		return this.content;
	}
	
	@Override
	public String toString(){
		return "Value[token="+token+", content="+content+"]";
	}
	
	public static class BiValue extends Value{
		
		private Value left;
		private String action;
		private Value right;
		
		public BiValue(Value left, String action, Value right){
			this.left = left;
			this.action = action;
			this.right = right;
		}
		
		public Value left(){
			return left;
		}
		
		public String getAction(){
			return this.action;
		}
		
		public Value right(){
			return right;
		}
		
		@Override
		public String toString(){
			return left+" "+action+" "+right;
		}
	}
	
	public static class TriValue extends Value{
		
		private Value check;
		private Value success;
		private Value fail;
		
		public TriValue(){}
		
		public Value getChecker(){
			return check;
		}
		
		public Value success(){
			return success;
		}
		
		public Value fail(){
			return fail;
		}
		
	}

}
